package unisa.gps.etour.control.GestioneUtentiRegistrati;

import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.sql.SQLException;

import unisa.gps.etour.bean.BeanTurista;
import unisa.gps.etour.repository.DBTurista;
import unisa.gps.etour.util.ControlloDati;
import unisa.gps.etour.util.MessaggiErrore;

public class Autenticazione extends UnicastRemoteObject implements IAutenticazione
{

	private static final long serialVersionUID = 0L;

	public Autenticazione() throws RemoteException
	{
		super();
	}

	// Oggetti per la manipolazione dei dati del Turista
	private DBTurista turista = new DBTurista();
	private BeanTurista bTurista;

	public int login(String pUsername, String pPassword, byte pTipologiaUtente)
			throws RemoteException
	{
		// Controlla la correttezza delle stringhe Username e Password
		if (ControlloDati.controllaStringa(pUsername, true, true, "_-", null,
				6, 12)
				&& ControlloDati.controllaStringa(pPassword, true, true, "_-",
						null, 5, 12))
			try
			{
				switch (pTipologiaUtente)
				{
					// Se la tipologia è Turista
					case TURISTA:
						// Richiama il metodo per ottenere il Bean del Turista
						// data l'username
						bTurista = turista.ottieniTurista(pUsername);
						// Controlla che la il Bean non sia nullo e la
						// corrispondenza tra le password
						if (bTurista != null
								&& bTurista.getPassword().equals(pPassword))
							return bTurista.getId();
						// Se la tipologia è Punto di Ristoro
					case OP_PUNTO_DI_RISTORO:
						// Non è stata implementata la parte operatore punto di
						// ristoro
						return -1;
						// Se non corrisponde ad alcuna tipologia nota
					default:
						return -1;
				}
			}
			catch (SQLException e)
			{
				throw new RemoteException(
						MessaggiErrore.ERRORE_DBMS);
			}
			catch (Exception e) {
				throw new RemoteException(MessaggiErrore.ERRORE_SCONOSCIUTO);
			}
		// Se i dati non sono corretti ritorna -1
		return -1;
	}
}
