package unisa.gps.etour.bean;

/**
 * Bean contenente i dati relativi al Banner
 * 
 * @author Miranda Mauro
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */

import java.io.Serializable;

public class BeanBanner implements Serializable
{
	private static final long serialVersionUID = -872783211721655763L;
	private int id;
	private int idPuntoDiRistoro;
	private String percorsoFile;

	/**
	 * Costruttore parametrizzato
	 * 
	 * @param pId
	 * @param pPercorsoFile
	 * @param pidPuntoDiRistoro
	 */

	public BeanBanner(int pId, String pPercorsoFile, int pidPuntoDiRistoro)
	{
		setId(pId);
		setPercorsoFile(pPercorsoFile);
		setIdPuntoDiRistoro(pidPuntoDiRistoro);
	}

	/**
	 * Costruttore Vuoto
	 * 
	 */
	public BeanBanner()
	{

	}

	/**
	 * Restituisce il valore di percorsoFile
	 * 
	 * @return Valore di percorsoFile.
	 */

	public String getPercorsoFile()
	{
		return percorsoFile;
	}

	/**
	 * Imposta il nuovo valore di percorsoFile
	 * 
	 * @param pPercorsoFile Nuovo valore di percorsoFile.
	 */
	public void setPercorsoFile(String pPercorsoFile)
	{
		percorsoFile = pPercorsoFile;
	}

	/**
	 * Restituisce il valore di id
	 * 
	 * @return Valore di id.
	 */
	public int getId()
	{
		return id;
	}

	/**
	 * Restituisce il valore di idPuntoDiRistoro
	 * 
	 * @return Valore di idPuntoDiRistoro.
	 */
	public int getIdPuntoDiRistoro()
	{
		return idPuntoDiRistoro;
	}

	/**
	 * Imposta il nuovo valore di id
	 *
	 * @param pId Nuovo valore di id.
	 */
	public void setId(int pId)
	{
		id = pId;
	}

	/**
	 * Imposta il nuovo valore di idPuntoDiRistoro
	 *
	 * @param pIdPuntoDiRistoro Nuovo valore di idPuntoDiRistoro.
	 */
	public void setIdPuntoDiRistoro(int pIdPuntoDiRistoro)
	{
		idPuntoDiRistoro = pIdPuntoDiRistoro;
	}

}
