package unisa.gps.etour.bean;
import java.io.Serializable;
import java.util.Date;
/**
 * Bean Contenente i dati relativi a una Convenzione
 * 
 * @author Martone Giuseppe
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */
public class BeanConvenzione implements Serializable
{

	private static final long serialVersionUID = -3255500940680220001L;
	private int id;
	private int maxBanner;
	private Date dataInizio;
	private Date dataFine;
	private double prezzo;
	private boolean attiva;
	private int idPuntoDiRistoro;

	/**
	 * Costruttore parametrizzato
	 * 
	 * @param pId
	 * @param pMaxBanner
	 * @param pDataInizio
	 * @param pDataFine
	 * @param pPrezzo
	 * @param pAttiva
	 * @param pidPuntoDiRistoro
	 */
	public BeanConvenzione(int pId, int pMaxBanner, Date pDataInizio,
			Date pDataFine, double pPrezzo, boolean pAttiva,
			int pidPuntoDiRistoro)
	{
		setId(pId);
		setMaxBanner(pMaxBanner);
		setDataInizio(pDataInizio);
		setDataFine(pDataFine);
		setPrezzo(pPrezzo);
		setAttiva(pAttiva);
		setIdPuntoDiRistoro(pidPuntoDiRistoro);
	}

	/**
	 * Costruttore Vuoto
	 * 
	 */
	public BeanConvenzione()
	{

	}

	/**
	 * Restituisce il valore di attiva
	 * 
	 * @return Valore di attiva.
	 */
	public boolean isAttiva()
	{
		return attiva;
	}

	/**
	 * Imposta il nuovo valore di attiva
	 *
	 * @param pAttiva Nuovo valore di attiva.
	 */
	public void setAttiva(boolean pAttiva)
	{
		attiva = pAttiva;
	}

	/**
	 * Restituisce il valore di dataFine
	 * 
	 * @return Valore di dataFine.
	 */
	public Date getDataFine()
	{
		return dataFine;
	}

	/**
	 * Imposta il nuovo valore di dataFine
	 *
	 * @param pDataFine Nuovo valore di dataFine.
	 */
	public void setDataFine(Date pDataFine)
	{
		dataFine = pDataFine;
	}

	/**
	 * Restituisce il valore di dataInizio
	 * 
	 * @return Valore di dataInizio.
	 */
	public Date getDataInizio()
	{
		return dataInizio;
	}

	/**
	 * Imposta il nuovo valore di dataInizio
	 *
	 * @param pDataInizio Nuovo valore di dataInizio.
	 */
	public void setDataInizio(Date pDataInizio)
	{
		dataInizio = pDataInizio;
	}

	/**
	 * Restituisce il valore di maxBanner
	 * 
	 * @return Valore di maxBanner.
	 */
	public int getMaxBanner()
	{
		return maxBanner;
	}

	/**
	 * Imposta il nuovo valore di maxBanner
	 *
	 * @param pMaxBanner Nuovo valore di maxBanner.
	 */
	public void setMaxBanner(int pMaxBanner)
	{
		maxBanner = pMaxBanner;
	}

	/**
	 * Restituisce il valore di prezzo
	 * 
	 * @return Valore di prezzo.
	 */
	public double getPrezzo()
	{
		return prezzo;
	}

	/**
	 * Imposta il nuovo valore di prezzo
	 *
	 * @param pPrezzo Nuovo valore di prezzo.
	 */
	public void setPrezzo(double pPrezzo)
	{
		prezzo = pPrezzo;
	}

	/**
	 * Restituisce il valore di id
	 * 
	 * @return Valore di id.
	 */
	public int getId()
	{
		return id;
	}

	/**
	 * Restituisce il valore di idPuntoDiRistoro
	 * 
	 * @return Valore di idPuntoDiRistoro.
	 */
	public int getIdPuntoDiRistoro()
	{
		return idPuntoDiRistoro;
	}

	/**
	 * Imposta il nuovo valore di id
	 *
	 * @param pId Nuovo valore di id.
	 */
	public void setId(int pId)
	{
		id = pId;
	}

	/**
	 * Imposta il nuovo valore di idPuntoDiRistoro
	 *
	 * @param pIdPuntoDiRistoro Nuovo valore di idPuntoDiRistoro.
	 */
	public void setIdPuntoDiRistoro(int pIdPuntoDiRistoro)
	{
		idPuntoDiRistoro = pIdPuntoDiRistoro;
	}

}
