package unisa.gps.etour.bean;
import java.io.Serializable;
/**
 * Bean Contenente i dati relativi a un Menu
 * 
 * @author Martone Giuseppe
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */
public class BeanMenu implements Serializable
{
	private static final long serialVersionUID = -3112032222839565409L;
	private int id;
	private String giorno;
	private int idPuntoDiRistoro;

	/**
	 * Costruttore parametrizzato
	 * 
	 * @param pId
	 * @param pGiorno
	 * @param pIdPuntoDiRistoro
	 */
	public BeanMenu(int pId, String pGiorno, int pIdPuntoDiRistoro)
	{
		setId(pId);
		setGiorno(pGiorno);
		setIdPuntoDiRistoro(pIdPuntoDiRistoro);
	}

	/**
	 * Costruttore Vuoto
	 */
	public BeanMenu()
	{

	}

	/**
	 * Restituisce il valore di giorno
	 * 
	 * @return Valore di giorno.
	 */
	public String getGiorno()
	{
		return giorno;
	}

	/**
	 * Imposta il nuovo valore di giorno
	 * 
	 * @param pGiorno Nuovo valore di giorno.
	 */
	public void setGiorno(String pGiorno)
	{
		giorno = pGiorno;
	}

	/**
	 * Restituisce il valore di id
	 * 
	 * @return Valore di id.
	 */
	public int getId()
	{
		return id;
	}

	/**
	 * Restituisce il valore di idPuntoDiRistoro
	 * 
	 * @return Valore di idPuntoDiRistoro.
	 */
	public int getIdPuntoDiRistoro()
	{
		return idPuntoDiRistoro;
	}

	/**
	 * Imposta il nuovo valore di id
	 * 
	 * @param pId Nuovo valore di id.
	 */
	public void setId(int pId)
	{
		id = pId;
	}

	/**
	 * Imposta il nuovo valore di idPuntoDiRistoro
	 * 
	 * @param pIdPuntoDiRistoro Nuovo valore di idPuntoDiRistoro.
	 */
	public void setIdPuntoDiRistoro(int pIdPuntoDiRistoro)
	{
		idPuntoDiRistoro = pIdPuntoDiRistoro;
	}

}
