package unisa.gps.etour.bean;
import java.io.Serializable;
/**
 * Bean Contenente i dati relativi a un Operatore Agenzia
 * 
 * @author Martone Giuseppe
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */
public class BeanOperatoreAgenzia implements Serializable
{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -3489147679484477440L;
	private int id;
	private String username;
	private String nome;
	private String cognome;
	private String password;
	
	/**
	 * Costruttore parametrizzato
	 * 
	 * @param pid
	 * @param pUsername
	 * @param pNome
	 * @param pCognome
	 * @param pPassword
	 */
	public BeanOperatoreAgenzia(int pid, String pUsername, String pNome,
			String pCognome, String pPassword)
	{
		setId(pid);
		setUsername(pUsername);
		setNome(pNome);
		setCognome(pCognome);
		setPassword(pPassword);
	}

	/**
	 * Costruttore Vuoto
	 */
	public BeanOperatoreAgenzia()
	{

	}

	/**
	 * Restituisce il valore di cognome
	 * 
	 * @return Valore di cognome.
	 */
	public String getCognome()
	{
		return cognome;
	}

	/**
	 * Imposta il nuovo valore di cognome
	 * 
	 * @param pCognome Nuovo valore di cognome.
	 */
	public void setCognome(String pCognome)
	{
		cognome = pCognome;
	}

	/**
	 * Restituisce il valore di nome
	 * 
	 * @return Valore di nome.
	 */
	public String getNome()
	{
		return nome;
	}

	/**
	 * Imposta il nuovo valore di nome
	 * 
	 * @param pNome Nuovo valore di nome.
	 */
	public void setNome(String pNome)
	{
		nome = pNome;
	}

	/**
	 * Restituisce il valore di password
	 * 
	 * @return Valore di password.
	 */
	public String getPassword()
	{
		return password;
	}

	/**
	 * Imposta il nuovo valore di password
	 * 
	 * @param pPassword Nuovo valore di password.
	 */
	public void setPassword(String pPassword)
	{
		password = pPassword;
	}

	/**
	 * Restituisce il valore di username
	 * 
	 * @return Valore di username.
	 */
	public String getUsername()
	{
		return username;
	}

	/**
	 * Imposta il nuovo valore di username
	 * 
	 * @param pUsername Nuovo valore di username.
	 */
	public void setUsername(String pUsername)
	{
		username = pUsername;
	}

	/**
	 * Imposta il nuovo valore di id
	 * 
	 * @param pid Nuovo valore di id.
	 */
	public void setId(int pid)
	{
		id = pid;
	}

	/**
	 * Restituisce il valore di id
	 * 
	 * @return Valore di id.
	 */
	public int getId()
	{
		return id;
	}

}
