package unisa.gps.etour.bean;

/**
 * Bean Contenente i dati relativi alle Preferenze Generiche
 * 
 * @author Miranda Mauro
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */

import java.io.Serializable;

public class BeanPreferenzeGeneriche implements Serializable
{
	private static final long serialVersionUID = 6805656922951334071L;
	private int id;
	private int dimensioneFont;
	private String font;
	private String tema;
	private int idTurista;

	/**
	 * Costruttore parametrizzato
	 * 
	 * @param pId
	 * @param pDimensioneFont
	 * @param pFont
	 * @param pTema
	 * @param pIdTurista
	 */
	public BeanPreferenzeGeneriche(int pId, int pDimensioneFont, String pFont,
			String pTema, int pIdTurista)
	{
		setId(pId);
		setDimensioneFont(pDimensioneFont);
		setFont(pFont);
		setTema(pTema);
		setIdTurista(pIdTurista);
	}

	/**
	 * Costruttore Vuoto
	 */
	public BeanPreferenzeGeneriche()
	{

	}

	/**
	 * Restituisce il valore di dimensioneFont
	 * 
	 * @return Valore di dimensioneFont.
	 */
	public int getDimensioneFont()
	{
		return dimensioneFont;
	}

	/**
	 * Imposta il nuovo valore di dimensioneFont
	 * 
	 * @param pDimensioneFont Nuovo valore di dimensioneFont.
	 */
	public void setDimensioneFont(int pDimensioneFont)
	{
		dimensioneFont = pDimensioneFont;
	}

	/**
	 * Restituisce il valore di font
	 * 
	 * @return Valore di font.
	 */
	public String getFont()
	{
		return font;
	}

	/**
	 * Imposta il nuovo valore di font
	 * 
	 * @param pFont Nuovo valore di font.
	 */
	public void setFont(String pFont)
	{
		font = pFont;
	}

	/**
	 * Restituisce il valore di tema
	 * 
	 * @return Valore di tema.
	 */
	public String getTema()
	{
		return tema;
	}

	/**
	 * Imposta il nuovo valore di tema
	 * 
	 * @param pTema Nuovo valore di tema.
	 */
	public void setTema(String pTema)
	{
		tema = pTema;
	}

	/**
	 * Restituisce il valore di id
	 * 
	 * @return Valore di id.
	 */
	public int getId()
	{
		return id;
	}

	/**
	 * Restituisce il valore di usernameTurista
	 * 
	 * @return Valore di usernameTurista.
	 */
	public int getIdTurista()
	{
		return idTurista;
	}

	/**
	 * Imposta il nuovo valore di usernameTurista
	 * 
	 * @param pIdTurista Nuovo valore di usernameTurista.
	 */
	public void setIdTurista(int pIdTurista)
	{
		idTurista = pIdTurista;
	}

	/**
	 * Imposta il nuovo valore di id
	 * 
	 * @param pId Nuovo valore di id.
	 */
	public void setId(int pId)
	{
		id = pId;
	}

}
