package unisa.gps.etour.bean;
import java.io.Serializable;
import java.util.Date;
/**
 * Bean Contenente i dati relativi a un Turista
 * 
 * @author Miranda Mauro
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */
public class BeanTurista implements Serializable
{
	private static final long serialVersionUID = 4214744963263090577L;
	private int id;
	private String username;
	private String nome;
	private String cognome;
	private String cittaNascita;
	private String cittaResidenza;
	private String telefono;
	private String cap;
	private String via;
	private String provincia;
	private String email;
	private String password;
	private Date dataNascita;
	private Date dataRegistrazione;
	private boolean attiva;

	/**
	 * Costruttore parametrizzato
	 * 
	 * @param pid
	 * @param pUsername
	 * @param pNome
	 * @param pCognome
	 * @param pCittaNascita
	 * @param pCittaResidenza
	 * @param pTelefono
	 * @param pCap
	 * @param pVia
	 * @param pProvincia
	 * @param pEmail
	 * @param pPassword
	 * @param pDataNascita
	 * @param pDataRegistrazione
	 * @param pAttiva
	 */
	public BeanTurista(int pid, String pUsername, String pNome,
			String pCognome, String pCittaNascita, String pCittaResidenza,
			String pTelefono, String pCap, String pVia, String pProvincia,
			String pEmail, String pPassword, Date pDataNascita,
			Date pDataRegistrazione, boolean pAttiva)
	{
		setId(pid);
		setUsername(pUsername);
		setNome(pNome);
		setCognome(pCognome);
		setCittaNascita(pCittaNascita);
		setCittaResidenza(pCittaResidenza);
		setTelefono(pTelefono);
		setCap(pCap);
		setVia(pVia);
		setProvincia(pProvincia);
		setEmail(pEmail);
		setPassword(pPassword);
		setDataNascita(pDataNascita);
		setDataRegistrazione(pDataRegistrazione);
		setAttiva(pAttiva);
	}

	/**
	 * Costruttore Vuoto
	 */
	public BeanTurista()
	{

	}

	/**
	 * Restituisce il valore di cap
	 * 
	 * @return Valore di cap.
	 */
	public String getCap()
	{
		return cap;
	}

	/**
	 * Imposta il nuovo valore di cap
	 * 
	 * @param pCap Nuovo valore di cap.
	 */
	public void setCap(String pCap)
	{
		cap = pCap;
	}

	/**
	 * Restituisce il valore di cittaNascita
	 * 
	 * @return Valore di cittaNascita.
	 */
	public String getCittaNascita()
	{
		return cittaNascita;
	}

	/**
	 * Imposta il nuovo valore di cittaNascita
	 * 
	 * @param pCittaNascita Nuovo valore di cittaNascita.
	 */
	public void setCittaNascita(String pCittaNascita)
	{
		cittaNascita = pCittaNascita;
	}

	/**
	 * Restituisce il valore di cittaResidenza
	 * 
	 * @return Valore di cittaResidenza.
	 */
	public String getCittaResidenza()
	{
		return cittaResidenza;
	}

	/**
	 * Imposta il nuovo valore di cittaResidenza
	 * 
	 * @param pCittaResidenza Nuovo valore di cittaResidenza.
	 */
	public void setCittaResidenza(String pCittaResidenza)
	{
		cittaResidenza = pCittaResidenza;
	}

	/**
	 * Restituisce il valore di cognome
	 * 
	 * @return Valore di cognome.
	 */
	public String getCognome()
	{
		return cognome;
	}

	/**
	 * Imposta il nuovo valore di cognome
	 * 
	 * @param pCognome Nuovo valore di cognome.
	 */
	public void setCognome(String pCognome)
	{
		cognome = pCognome;
	}

	/**
	 * Restituisce il valore di dataNascita
	 * 
	 * @return Valore di dataNascita.
	 */
	public Date getDataNascita()
	{
		return dataNascita;
	}

	/**
	 * Imposta il nuovo valore di dataNascita
	 * 
	 * @param pDataNascita Nuovo valore di dataNascita.
	 */
	public void setDataNascita(Date pDataNascita)
	{
		dataNascita = pDataNascita;
	}

	/**
	 * Restituisce il valore di dataRegistrazione
	 * 
	 * @return Valore di dataRegistrazione.
	 */
	public Date getDataRegistrazione()
	{
		return dataRegistrazione;
	}

	/**
	 * Imposta il nuovo valore di dataRegistrazione
	 * 
	 * @param pDataRegistrazione Nuovo valore di dataRegistrazione.
	 */
	public void setDataRegistrazione(Date pDataRegistrazione)
	{
		dataRegistrazione = pDataRegistrazione;
	}

	/**
	 * Restituisce il valore di email
	 * 
	 * @return Valore di email.
	 */
	public String getEmail()
	{
		return email;
	}

	/**
	 * Imposta il nuovo valore di email
	 * 
	 * @param pEmail Nuovo valore di email.
	 */
	public void setEmail(String pEmail)
	{
		email = pEmail;
	}

	/**
	 * Restituisce il valore di nome
	 * 
	 * @return Valore di nome.
	 */
	public String getNome()
	{
		return nome;
	}

	/**
	 * Imposta il nuovo valore di nome
	 * 
	 * @param pNome Nuovo valore di nome.
	 */
	public void setNome(String pNome)
	{
		nome = pNome;
	}

	/**
	 * Restituisce il valore di password
	 * 
	 * @return Valore di password.
	 */
	public String getPassword()
	{
		return password;
	}

	/**
	 * Imposta il nuovo valore di password
	 * 
	 * @param pPassword Nuovo valore di password.
	 */
	public void setPassword(String pPassword)
	{
		password = pPassword;
	}

	/**
	 * Restituisce il valore di provincia
	 * 
	 * @return Valore di provincia.
	 */
	public String getProvincia()
	{
		return provincia;
	}

	/**
	 * Imposta il nuovo valore di provincia
	 * 
	 * @param pProvincia Nuovo valore di provincia.
	 */
	public void setProvincia(String pProvincia)
	{
		provincia = pProvincia;
	}

	/**
	 * Restituisce il valore di telefono
	 * 
	 * @return Valore di telefono.
	 */
	public String getTelefono()
	{
		return telefono;
	}

	/**
	 * Imposta il nuovo valore di telefono
	 * 
	 * @param pTelefono Nuovo valore di telefono.
	 */
	public void setTelefono(String pTelefono)
	{
		telefono = pTelefono;
	}

	/**
	 * Restituisce il valore di via
	 * 
	 * @return Valore di via.
	 */
	public String getVia()
	{
		return via;
	}

	/**
	 * Imposta il nuovo valore di via
	 * 
	 * @param pVia Nuovo valore di via.
	 */
	public void setVia(String pVia)
	{
		via = pVia;
	}

	/**
	 * Restituisce il valore di username
	 * 
	 * @return Valore di username.
	 */
	public String getUsername()
	{
		return username;
	}

	/**
	 * Restituisce come valore 1 oppure 0, indicando se un turista � o non �
	 * attivo
	 * 
	 * @return Valore di attivazione
	 */
	public boolean isAttiva()
	{
		return attiva;
	}

	/**
	 * Imposta il nuovo valore di attiva
	 * 
	 * @param pAttiva Nuovo valore di attiva.
	 */
	public void setAttiva(boolean pAttiva)
	{
		attiva = pAttiva;
	}

	/**
	 * Imposta il nuovo valore di username
	 * 
	 * @param pUsername Nuovo valore di username.
	 */
	public void setUsername(String pUsername)
	{
		username = pUsername;
	}

	/**
	 * Imposta il nuovo valore di id
	 * 
	 * @param pid Nuovo valore di id.
	 */
	public void setId(int pid)
	{
		id = pid;
	}

	/**
	 * Restituisce il valore di id
	 * 
	 * @return Valore di id.
	 */
	public int getId()
	{
		return id;
	}

}
