package unisa.gps.etour.bean;
import java.io.Serializable;
import java.util.Date;
/**
 * Bean Contenente i dati relativi ai feedback per un Punto di Ristoro
 * 
 * @author Martone Giuseppe
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */
public class BeanVisitaPR implements Serializable
{

	private static final long serialVersionUID = -4065240072283418782L;
	private int voto;
	private int idPuntoDiRistoro;
	private String commento;
	private int IdTurista;
	private Date dataVisita;

	/**
	 * Costruttore parametrizzato
	 * 
	 * @param pVoto
	 * @param pIdPuntoDiRistoro
	 * @param pCommento
	 * @param pIdTurista
	 * @param pDataVisita
	 */
	public BeanVisitaPR(int pVoto, int pIdPuntoDiRistoro,
			String pCommento, int pIdTurista, Date pDataVisita)
	{
		setVoto(pVoto);
		setIdPuntoDiRistoro(pIdPuntoDiRistoro);
		setCommento(pCommento);
		setIdTurista(pIdTurista);
		setDataVisita(pDataVisita);
	}

	/**
	 * Costruttore Vuoto
	 */
	public BeanVisitaPR()
	{

	}

	/**
	 * Restituisce il valore di commento
	 * 
	 * @return Valore di commento.
	 */
	public String getCommento()
	{
		return commento;
	}

	/**
	 * Imposta il nuovo valore di commento
	 * 
	 * @param pCommento Nuovo valore di commento.
	 */
	public void setCommento(String pCommento)
	{
		commento = pCommento;
	}

	/**
	 * Restituisce il valore di dataVisita
	 * 
	 * @return Valore di dataVisita.
	 */
	public Date getDataVisita()
	{
		return dataVisita;
	}

	/**
	 * Imposta il nuovo valore di dataVisita
	 * 
	 * @param pDataVisita Nuovo valore di dataVisita.
	 */
	public void setDataVisita(Date pDataVisita)
	{
		dataVisita = pDataVisita;
	}

	/**
	 * Restituisce il valore di idPuntoDiRistoro
	 * 
	 * @return Valore di idPuntoDiRistoro.
	 */
	public int getIdPuntoDiRistoro()
	{
		return idPuntoDiRistoro;
	}

	/**
	 * Imposta il nuovo valore di idPuntoDiRistoro
	 * 
	 * @param pIdPuntoDiRistoro Nuovo valore di idPuntoDiRistoro.
	 */
	public void setIdPuntoDiRistoro(int pIdPuntoDiRistoro)
	{
		idPuntoDiRistoro = pIdPuntoDiRistoro;
	}

	/**
	 * Restituisce il valore di IdTurista
	 * 
	 * @return Valore di IdTurista.
	 */
	public int getIdTurista()
	{
		return IdTurista;
	}

	/**
	 * Imposta il nuovo valore di IdTurista
	 * 
	 * @param pIdTurista Nuovo valore di IdTurista.
	 */
	public void setIdTurista(int pIdTurista)
	{
		IdTurista = pIdTurista;
	}

	/**
	 * Restituisce il valore di voto
	 * 
	 * @return Valore di voto.
	 */
	public int getVoto()
	{
		return voto;
	}

	/**
	 * Imposta il nuovo valore di voto
	 * 
	 * @param pVoto Nuovo valore di voto.
	 */
	public void setVoto(int pVoto)
	{
		voto = pVoto;
	}

}
