package unisa.gps.etour.repository;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;

import unisa.gps.etour.bean.BeanMenu;

/**
 * Classe che implementa l'interfaccia Menu
 * 
 * @author Martone Giuseppe
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */
public class DBMenu implements IDBMenu
{
	// Costruttore vuoto
	public DBMenu()
	{

	}

	public boolean cancellaMenu(int pIdMenu) throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query di cancellazione
			String query = "DELETE FROM menu WHERE Id =" + pIdMenu;
			// Si esegue la query di Cancellazione
			int i = stat.executeUpdate(query);
			// Si restituisce il backup
			return (i == 1);
		}
		// Viene sempre eseguito e si occupa di chiudere lo Statement e la
		// Connessione
		finally
		{
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}

	}

	public boolean inserisciMenu(BeanMenu pMenu) throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query per l'inserimento
			String query = "INSERT INTO menu(Giorno,IdPuntoDiRistoro) VALUES ('"
					+ pMenu.getGiorno()
					+ "',"
					+ pMenu.getIdPuntoDiRistoro()
					+ ")";
			// Si esegue la query di Inserimento
			int i = stat.executeUpdate(query);
			// Si ritorna il backup
			return (i == 1);
		}
		// Viene eseguito sempre e si occupa di chiudere lo Statement e la
		// Connessione
		finally
		{
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

	public boolean modificaMenu(BeanMenu pMenu) throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query di modifica
			String query = "UPDATE  menu  SET " + "Giorno = '"
					+ pMenu.getGiorno() + "'  WHERE Id = " + pMenu.getId();
			// Si esegue la query di Modifica
			int i = stat.executeUpdate(query);
			// Si ritorna il backup
			return (i == 1);
		}
		// Viene sempre eseguito e si occupa di chiudere lo Statement e la
		// Connessione
		finally
		{
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

	public ArrayList<BeanMenu> ottieniMenu(int pIdPuntoDiRistoro)
			throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		// Variabile per i risultati delle query
		ResultSet result = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query per l'estrazione della lista dei Menu
			String query = "SELECT * FROM menu WHERE IdPuntoDiRistoro ="
					+ pIdPuntoDiRistoro;
			// Viene eseguita la query
			result = stat.executeQuery(query);
			// Lista che conterrà tutti i BeanMenu ottenuti
			ArrayList<BeanMenu> lista = new ArrayList<BeanMenu>();
			// Si estraggono i risultati dal result set e si inseriscono nella
			// lista
			// da restituire
			while (result.next())
			{
				// Riempio la lista
				lista
						.add(new BeanMenu(result.getInt("Id"), result
								.getString("Giorno"), result
								.getInt("IdPuntoDiRistoro")));
			}
			// Ritorno la lista
			return lista;
		}
		// Viene sempre eseguito e si occupa di chiudere il Result, lo Statement
		// e la Connessione
		finally
		{
			if (result != null)
			{
				result.close();
			}
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}

	}

	public BeanMenu ottieniMenuDelGiorno(int pIdPuntoDiRistoro, String pGiorno)
			throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		// Variabile per i risultati delle query
		ResultSet result = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query per l'estrazione del Menu del giorno
			String query = "SELECT * FROM menu WHERE IdPuntoDiRistoro = "
					+ pIdPuntoDiRistoro + " AND Giorno ='" + pGiorno + "'";
			// Viene eseguita la query
			result = stat.executeQuery(query);
			// Ottengo il bean del menu del giorno in base all'id del punto di
			// ristoro e al giorno
			BeanMenu beanTemp = null;
			if (result.next())
			{
				// Creo il Bean ricavato
				beanTemp = new BeanMenu(result.getInt("Id"), result
						.getString("Giorno"), result.getInt("IdPuntoDiRistoro"));
			}
			// Ritorno il Bean ottenuto
			return beanTemp;
		}
		// Viene sempre eseguito e si occupa di chiudere il Result, lo Statement
		// e la Connessione
		finally
		{
			if (result != null)
			{
				result.close();
			}
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}

	}

}
