package unisa.gps.etour.repository;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import unisa.gps.etour.bean.BeanOperatorePuntoDiRistoro;

/**
 * Classe che implementa l'interfaccia Operatore Punto Di Ristoro
 * 
 * @author Martone Giuseppe
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */
public class DBOperatorePuntoDiRistoro implements IDBOperatorePuntoDiRistoro
{
	// Costruttore vuoto
	public DBOperatorePuntoDiRistoro()
	{

	}

	public boolean cancellaOperatorePuntoDiRistoro(int pIdOperatore)
			throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		try
		{
			// Ottengo connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query di cancellazione
			String query = "DELETE FROM operatorepuntodiristoro WHERE Id ="
					+ pIdOperatore;
			// Si esegue la query di Cancellazione
			int i = stat.executeUpdate(query);
			// Si restituisce il backup
			return (i == 1);
		}
		// Viene eseguito sempre e si occupa di chiudere lo Statement e la
		// Connessione
		finally
		{
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

	public boolean inserisciOperatorePuntoDiRistoro(
			BeanOperatorePuntoDiRistoro pOperatore) throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		// Variabile per i risultati delle query
		ResultSet unico = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query per l'inserimento
			String query = "INSERT INTO operatorepuntodiristoro(Nome,Cognome,"
					+ "Username,Password,Email,IdPuntoDiRistoro) VALUES ('"
					+ pOperatore.getNome() + "','" + pOperatore.getCognome()
					+ "','" + pOperatore.getUsername() + "','"
					+ pOperatore.getPassword() + "','" + pOperatore.getEmail()
					+ "'," + pOperatore.getIdPuntoDiRistoro() + ")";
			// Query per il controllo sull'Id del PuntoDiRistoro in quanto
			// l'associazione è 1 a 1 tra OPPR e PR
			String unicita = "SELECT IdPuntoDiRistoro FROM operatorepuntodiristoro WHERE IdPuntoDiRistoro = "
					+ pOperatore.getIdPuntoDiRistoro();
			// Eseguo la query per il controllo
			unico = stat.executeQuery(unicita);
			int j = 0;
			// Controllo se ci sono tuple
			while (unico.next())
				j++;
			// Se è vuoto
			if (j == 0)
			{
				// Si esegue la query di Inserimento
				int i = stat.executeUpdate(query);
				// Si ritorna il backup
				System.out.println("Ho inserito L'Operatore PR");
				return (i == 1);
			}
			// Altrimenti già esiste
			else
			{
				System.out.println("Operatore PR già esistente per il PR");
				return false;
			}
		}
		// Viene eseguito sempre e si occupa di chiudere lo Statement e la
		// Connessione
		finally
		{
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
			if (unico != null)
			{
				unico.close();
			}
		}
	}

	public boolean modificaOperatorePuntoDiRistoro(
			BeanOperatorePuntoDiRistoro pOperatore) throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query di modifica
			String query = "UPDATE operatorepuntodiristoro  SET " + " Nome = '"
					+ pOperatore.getNome() + "', Cognome = '"
					+ pOperatore.getCognome() + "', Password = '"
					+ pOperatore.getPassword() + "', Email = '"
					+ pOperatore.getEmail() + "' WHERE IdPuntoDiRistoro = "
					+ pOperatore.getIdPuntoDiRistoro();
			// Si esegue la query di Modifica
			int i = stat.executeUpdate(query);
			// Si ritorna il backup
			return (i == 1);
		}
		// Viene eseguito sempre e si occupa di chiudere lo Statement e la
		// Connessione
		finally
		{
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

	public BeanOperatorePuntoDiRistoro ottieniOperatorePuntoDiRistoro(
			int pIdOperatore) throws SQLException
	{

		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		// Variabile per i risultati delle query
		ResultSet result = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query per l'estrazione dell'operatore punto di ristoro richiesto
			String query = "SELECT * FROM operatorepuntodiristoro WHERE Id = "
					+ pIdOperatore;
			// Viene eseguita la query
			result = stat.executeQuery(query);
			// Ottengo il bean dell'Operatore punto di ristoro passando l'id
			BeanOperatorePuntoDiRistoro beanTemp = null;
			if (result.next())
			{
				// Construisco il BeanOPR
				beanTemp = new BeanOperatorePuntoDiRistoro(result.getInt("Id"),
						result.getString("Nome"), result.getString("Cognome"),
						result.getString("Username"), result
								.getString("Password"), result
								.getString("Email"), result
								.getInt("IdPuntoDiRistoro"));
			}
			return beanTemp;
		}
		// Eccezione se c'è un errore
		catch (Exception e)
		{
			throw new SQLException();
		}
		// Viene eseguito sempre e si occupa di chiudere il Result, lo Statement
		// e la Connessione
		finally
		{
			if (result != null)
			{
				result.close();
			}
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

}
