package unisa.gps.etour.repository;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;

import unisa.gps.etour.bean.BeanPiatto;

/**
 * Classe che implementa l'interfaccia Piatto
 * 
 * @author Martone Giuseppe
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */
public class DBPiatto implements IDBPiatto
{
	// Costruttore vuoto
	public DBPiatto()
	{

	}

	public boolean cancellaPiatto(int pIdPiatto) throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query di cancellazione
			String query = "DELETE FROM piatti WHERE Id =" + pIdPiatto;
			// Si esegue la query di Cancellazione
			int i = stat.executeUpdate(query);
			// Si restituisce il backup
			return (i == 1);
		}
		// Viene eseguito sempre e si occupa di chiudere lo Statement e la
		// Connessione
		finally
		{
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

	public boolean inserisciPiatto(BeanPiatto pPiatto) throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query per l'inserimento
			String query = "INSERT INTO piatti(Nome, Prezzo, IdMenu) VALUES ('"
					+ pPiatto.getNome() + "'," + pPiatto.getPrezzo() + ","
					+ pPiatto.getIdMenu() + ")";
			// Si esegue la query di Inserimento
			int i = stat.executeUpdate(query);
			// Si ritorna il backup
			return (i == 1);
		}
		// Viene eseguito sempre e si occupa di chiudere lo Statement e la
		// Connessione
		finally
		{
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

	public boolean modificaPiatto(BeanPiatto pPiatto) throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query di modifica
			String query = "UPDATE piatti  SET " + " Nome = '"
					+ pPiatto.getNome() + "' , Prezzo = " + pPiatto.getPrezzo()
					+ ", IdMenu = " + pPiatto.getIdMenu() + "  WHERE Id = "
					+ pPiatto.getId();
			// Si esegue la query di Modifica
			int i = stat.executeUpdate(query);
			// Si ritorna il backup
			return (i == 1);
		}
		// Viene eseguito sempre e si occupa di chiudere lo Statement e la
		// Connessione
		finally
		{
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

	public ArrayList<BeanPiatto> ottieniPiatto(int pIdMenu) throws SQLException
	{
		// Variabile per la connessione al database
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		// Variabile per i risultati delle query
		ResultSet result = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query per l'estrazione della lista dei piatti dato l'id del Menu
			String query = "SELECT * FROM piatti WHERE IdMenu = " + pIdMenu;
			// Viene eseguita la query
			result = stat.executeQuery(query);
			// Lista che conterrà tutti i Piatti ottenuti
			ArrayList<BeanPiatto> lista = new ArrayList<BeanPiatto>();
			// Si estraggono i risultati dal result set e si inseriscono nella
			// lista
			// da restituire
			while (result.next())
			{
				// Aggiungo nella lista il BeanPiatto
				lista.add(new BeanPiatto(result.getInt("Prezzo"), result
						.getString("Nome"), result.getInt("IdMenu"), result
						.getInt("Id")));
			}
			return lista;
		}
		// Viene eseguito sempre e si occupa di chiudere il Result, lo Statement
		// e la Connessione
		finally
		{
			if (result != null)
			{
				result.close();
			}
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

}
