package unisa.gps.etour.repository;

import java.sql.Connection;
import java.sql.Date;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;

import unisa.gps.etour.bean.BeanVisitaPR;

/**
 * Classe che implementa l'interfaccia IDBVisitaPR
 * 
 * @author Martone Giuseppe
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */
public class DBVisitaPR implements IDBVisitaPR
{
	// Costruttore vuoto
	public DBVisitaPR()
	{

	}

	public boolean inserisciVisitaPR(BeanVisitaPR pVisita) throws SQLException
	{
		// Variabile per la connessione
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		// Variabile per i risultati delle query
		ResultSet result = null;
		try
		{
			// Creo la data di visita
			java.sql.Date dataVisita = new Date(pVisita.getDataVisita()
					.getTime());
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query per ottenere la media dei voti di un bene
			String queryMediaVoti = "SELECT MediaVoti, NumeroVoti FROM puntodiristoro WHERE Id ="
					+ pVisita.getIdPuntoDiRistoro();
			result = stat.executeQuery(queryMediaVoti);
			// Variabile per la media dei voti
			double media = 0;
			// Variabile per il numero di voti
			int numeroVoti = 0;
			if (result.next())
			{
				media = result.getDouble("MediaVoti");
				numeroVoti = result.getInt("NumeroVoti");
				media = ((media * numeroVoti) + pVisita.getVoto())
						/ ++numeroVoti;
			}
			// Query per l'inserimento
			String query = "INSERT INTO visitapr(IdTurista, IdPuntoDiRistoro, DataVisita, Voto, Commento) VALUES ("
					+ pVisita.getIdTurista()
					+ " ,"
					+ pVisita.getIdPuntoDiRistoro()
					+ " ,'"
					+ dataVisita
					+ "',"
					+ pVisita.getVoto() + " ,'" + pVisita.getCommento() + "')";
			String query2 = "UPDATE puntodiristoro SET MediaVoti = " + media
					+ ", NumeroVoti = " + numeroVoti + " WHERE Id="
					+ pVisita.getIdPuntoDiRistoro();
			// Si esegue la query di Inserimento
			stat.executeQuery("BEGIN");
			int i = stat.executeUpdate(query);
			i = i * stat.executeUpdate(query2);
			stat.executeQuery("COMMIT");
			// Si ritorna il backup
			return (i == 1);
		}
		// Viene eseguito sempre e si occupa di chiudere il Result, lo Statement
		// e la Connessione
		finally
		{
			if (result != null)
			{
				result.close();
			}
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

	public boolean modificaVisitaPR(BeanVisitaPR pVisita) throws SQLException
	{
		// Variabile per la connessione
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		try
		{
			// Creo la data di visita
			java.sql.Date dataVisita = new Date(pVisita.getDataVisita()
					.getTime());
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query di modifica
			String query = "UPDATE visitapr  SET  " + " DataVisita = '"
					+ dataVisita + "', Commento = '" + pVisita.getCommento()
					+ "' WHERE IdPuntoDiRistoro = "
					+ pVisita.getIdPuntoDiRistoro() + " AND IdTurista = "
					+ pVisita.getIdTurista();
			// Si esegue la query di Modifica
			int i = stat.executeUpdate(query);
			// Si ritorna il backup
			return (i == 1);
		}
		// Viene eseguito sempre e si occupa di chiudere il Result, lo Statement
		// e la Connessione
		finally
		{
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}

	}

	public ArrayList<BeanVisitaPR> ottieniListaVisitaPR(int pIdPuntoDiRistoro)
			throws SQLException
	{
		// Variabile per la connessione
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		// Variabile per i risultati delle query
		ResultSet result = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query per l'estrazione della lista delle visite per un certo
			// punto di ristoro
			String query = "SELECT * FROM visitapr WHERE IdPuntoDiRistoro = "
					+ pIdPuntoDiRistoro;
			// Viene eseguita la query
			result = stat.executeQuery(query);
			ArrayList<BeanVisitaPR> lista = new ArrayList<BeanVisitaPR>();
			// Si estraggono i risultati dal result set e si inseriscono nella
			// lista
			// da restituire
			while (result.next())
			{
				java.util.Date dataVisita = new java.util.Date(result.getDate(
						"DataVisita").getTime());
				lista.add(new BeanVisitaPR(result.getInt("Voto"), result
						.getInt("IdPuntoDiRistoro"), result
						.getString("Commento"), result.getInt("IdTurista"),
						dataVisita));
			}
			return lista;
		}
		// Viene eseguito sempre e si occupa di chiudere il Result, lo Statement
		// e la Connessione
		finally
		{
			if (result != null)
			{
				result.close();
			}
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}

	}

	public ArrayList<BeanVisitaPR> ottieniListaVisitaPRTurista(int pIdTurista)
			throws SQLException
	{
		// Variabile per la connessione
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		// Variabile per i risultati delle query
		ResultSet result = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query per l'estrazione della lista delle visite per un certo
			// punto di ristoro di un Turista
			String query = "SELECT * FROM visitapr WHERE IdTurista = "
					+ pIdTurista;
			// Viene eseguita la query
			result = stat.executeQuery(query);
			// Lista che conterrà i BeanVisitaPR
			ArrayList<BeanVisitaPR> lista = new ArrayList<BeanVisitaPR>();
			// Si estraggono i risultati dal result set e si inseriscono nella
			// lista
			// da restituire
			while (result.next())
			{
				// Aggiungo i BeanVisitaPR alla lista
				java.util.Date dataVisita = new java.util.Date(result.getDate(
						"DataVisita").getTime());
				lista.add(new BeanVisitaPR(result.getInt("Voto"), result
						.getInt("IdPuntoDiRistoro"), result
						.getString("Commento"), result.getInt("IdTurista"),
						dataVisita));
			}
			// Ritorno la lista
			return lista;
		}
		// Viene eseguito sempre e si occupa di chiudere il Result, lo Statement
		// e la Connessione
		finally
		{
			if (result != null)
			{
				result.close();
			}
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}

	}

	public BeanVisitaPR ottieniVisitaPR(int pIdPuntoDiRistoro, int pIdTurista)
			throws SQLException
	{
		// Variabile per la connessione
		Connection conn = null;
		// Variabile per le query
		Statement stat = null;
		// Variabile per i risultati delle query
		ResultSet result = null;
		try
		{
			// Ottengo la connessione
			conn = DBConnessionePool.ottieniConnessione();
			// Creazione dello Statement
			stat = conn.createStatement();
			// Query per l'estrazione della visita effettuata da un turista per
			// un determinato punto di ristoro
			String query = "SELECT * FROM visitapr WHERE IdPuntoDiRistoro = "
					+ pIdPuntoDiRistoro + " AND IdTurista =  " + pIdTurista;
			// Viene eseguita la query
			result = stat.executeQuery(query);
			// Ottengo il bean della visita cercata in base all'id del turista e
			// del punto di ristoro
			BeanVisitaPR beanTemp = null;
			if (result.next())
			{
				// Creo il BeanVisitaPR
				java.util.Date dataVisita = new java.util.Date(result.getDate(
						"DataVisita").getTime());
				beanTemp = new BeanVisitaPR(result.getInt("Voto"), result
						.getInt("IdPuntoDiRistoro"), result
						.getString("Commento"), result.getInt("IdTurista"),
						dataVisita);
			}
			// Ritorno il BeanTemp
			return beanTemp;
		}
		// Viene eseguito sempre e si occupa di chiudere il Result, lo Statement
		// e la Connessione
		finally
		{
			if (result != null)
			{
				result.close();
			}
			if (stat != null)
			{
				stat.close();
			}
			if (conn != null)
			{
				DBConnessionePool.rilasciaConnessione(conn);
			}
		}
	}

}
