package unisa.gps.etour.control.GestioneTag;

import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.sql.SQLException;
import java.util.ArrayList;
import unisa.gps.etour.bean.BeanTag;
/*
 * Per i test import unisa.gps.etour.control.GestioneTag.test.stub.DBTag;
 */
import unisa.gps.etour.repository.DBTag;
import unisa.gps.etour.repository.IDBTag;
import unisa.gps.etour.util.MessaggiErrore;

/**
 * Classe che implementa le operazioni comuni per l'uso dei tag
 * 
 * @author Morelli Giuseppe
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */
public class GestioneTagComune extends UnicastRemoteObject implements
		IGestioneTagComune
{

	private static final long serialVersionUID = 1L;
	// Oggetto per la connessione al Database
	protected IDBTag tag;

	public GestioneTagComune() throws RemoteException
	{
		super();
		// Connessione al Database
		try
		{
			tag = new DBTag();
		}
		catch (Exception e)
		{
			throw new RemoteException(MessaggiErrore.ERRORE_SCONOSCIUTO);
		}
	}

	// Metodo che restituisce tutti i Tag
	public ArrayList<BeanTag> ottieniTags() throws RemoteException
	{
		// ArrayList da riempire con i tag per la restituzione
		ArrayList<BeanTag> toReturn;
		// Recupero dei dati dal Database
		try
		{
			// Ottengo le informazioni dal Database
			toReturn = tag.ottieniListaTag();
		}
		// Eccezione nell'esecuzione delle operazioni sul Database
		catch (SQLException e)
		{
			System.out
					.println("Errore nel metodo ottieniTags: " + e.toString());
			throw new RemoteException(MessaggiErrore.ERRORE_DBMS);
		}
		// Eccezioni impreviste causate da altri fattori
		catch (Exception ee)
		{
			System.out.println("Errore nel metodo ottieniTags: "
					+ ee.toString());
			throw new RemoteException(MessaggiErrore.ERRORE_SCONOSCIUTO);
		}
		// Controllo i dati di ritorno in modo da non restituire valori nulli al
		// chiamante
		if (toReturn == null)
			throw new RemoteException(MessaggiErrore.ERRORE_FORMATO_BEAN);
		return toReturn;
	}
}
