package unisa.gps.etour.repository;

import java.sql.SQLException;

import unisa.gps.etour.bean.BeanOperatoreAgenzia;

/**
 * Interfaccia per la gestione del OperatoreAgenzia nel database
 * 
 * @author Martone Giuseppe
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */
public interface IDBOperatoreAgenzia
{
	/**
	 * Restituisce i dati dell'Operatore Agenzia con Identificativo uguale a quello dato in
	 * input
	 * 
	 * @param pUsername Username dell'OperatoreAgenzia da trovare
	 * @return OperatoreAGenzia con id uguale a quello in input, Null se non esiste
	 * @throws SQLException
	 */
	public BeanOperatoreAgenzia ottieniOperatoreAgenzia(String pUsername) throws SQLException;
	
	/**
	 * Restituisce i dati dell'Operatore Agenzia con Identificativo uguale a quello dato in
	 * input
	 * 
	 * @param pUsername Username dell'OperatoreAgenzia da trovare
	 * @return OperatoreAGenzia con id uguale a quello in input, Null se non esiste
	 * @throws SQLException
	 */
	public boolean modificaPassword(BeanOperatoreAgenzia pOa) throws SQLException;

}
