package unisa.gps.etour.repository;

import java.sql.SQLException;

import unisa.gps.etour.bean.BeanOperatorePuntoDiRistoro;

/**
 * Interfaccia per la gestione dell'Operatore del punto di ristoro nel database
 * 
 * @author Martone Giuseppe
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */
public interface IDBOperatorePuntoDiRistoro
{
	/**
	 * Aggiunge un operatore punto di ristoro
	 * 
	 * @param pOperatore Operatore da aggiungere
	 * @throws SQLException
	 */
	public boolean inserisciOperatorePuntoDiRistoro(
			BeanOperatorePuntoDiRistoro pOperatore) throws SQLException;

	/**
	 * Modifica un operatore nel database
	 * 
	 * @param pOperatore Nuovi dati dell'Operatore
	 * @throws SQLException
	 * @return True se c'e' stata una modifica false altrimenti
	 */
	public boolean modificaOperatorePuntoDiRistoro(
			BeanOperatorePuntoDiRistoro pOperatore) throws SQLException;

	/**
	 * Elimina un operatore
	 * 
	 * @param pIdOperatore Identificativo Operatore da eliminare
	 * @throws SQLException
	 * @return True se e' stato cancellato false altrimenti
	 */
	public boolean cancellaOperatorePuntoDiRistoro(int pIdOperatore)
			throws SQLException;

	/**
	 * Restituisce i dati dell'operatore
	 * 
	 * @param pIdOperatore Id dell'operatore
	 * @throws SQLException
	 * @return Operatore punto di ristoro
	 */
	public BeanOperatorePuntoDiRistoro ottieniOperatorePuntoDiRistoro(
			int pIdOperatore) throws SQLException;
}
