package unisa.gps.etour.repository;

import java.sql.SQLException;
import java.util.ArrayList;

import unisa.gps.etour.bean.BeanPiatto;

/**
 * Interfaccia per la gestione dei Piatti nel database
 * 
 * @author Martone Giuseppe
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */
public interface IDBPiatto
{
	/**
	 * Aggiunge un piatto
	 * 
	 * @param pPiatti Piatto da aggiungere
	 */
	public boolean inserisciPiatto(BeanPiatto pPiatto) throws SQLException;

	/**
	 * Modifica i dati di un piatto nel database
	 * 
	 * @param pPiatti Dati del piatto da inserire nel database
	 * @return True se c'e' stata una modifica false altrimenti
	 */
	public boolean modificaPiatto(BeanPiatto pPiatto) throws SQLException;

	/**
	 * Elimina un piatto dal database
	 * 
	 * @param pIdPiatto Identificativo Piatto da eliminre
	 * @throws SQLException
	 * @return True se e' stato cancellato false altrimenti
	 */
	public boolean cancellaPiatto(int pIdPiatto) throws SQLException;

	/**
	 * Restituisce la lista dei piatti di un menu
	 * 
	 * @param pIdMenu Identificativo del menu
	 * @throws SQLException
	 * @return Lista dei piatti contenuti nel menu
	 */
	public ArrayList<BeanPiatto> ottieniPiatto(int pIdMenu) throws SQLException;

}
