package unisa.gps.etour.repository;

import java.sql.SQLException;

import unisa.gps.etour.bean.BeanPreferenzeGeneriche;

/**
 * Interfaccia per la gestione delle Preferenze generiche nel database
 * 
 * @author Miranda Mauro
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */
public interface IDBPreferenzeGeneriche
{
	/**
	 * Aggiunge una preferenza Generica
	 * 
	 * @param pPreferenza Preferenza da aggiungere
	 * @throws SQLException
	 */
	public boolean inserisciPreferenzaGenenerica(
			BeanPreferenzeGeneriche pPreferenza) throws SQLException;

	/**
	 * Modifica una preferenza generica
	 * 
	 * @param pPreferenza Preferenza da modificare
	 * @throws SQLException
	 * @return True se e' stata modificata false altrimenti
	 */
	public boolean modificaPreferenzaGenerica(
			BeanPreferenzeGeneriche pPreferenza) throws SQLException;

	/**
	 * Elimina una preferenza generica
	 * 
	 * @param pIdPreferenza Identificativo Preferenza da eliminare
	 * @throws SQLException
	 * @return True se e' stata cancellata false altrimenti
	 */
	public boolean cancellaPreferenzaGenerica(int pIdPreferenza)
			throws SQLException;

	/**
	 * Restituisce la preferenza generica di un turista
	 * 
	 * @param pIdTurista Id del turista
	 * @throws SQLException
	 * @return Preferenza generica
	 */
	public BeanPreferenzeGeneriche ottieniPreferenzaGenerica(int pIdTurista)
			throws SQLException;
}
