package unisa.gps.etour.repository;

import java.sql.SQLException;
import java.util.ArrayList;

import unisa.gps.etour.bean.BeanVisitaBC;

/**
 * Interfaccia per la gestione dei feedback relativi ad un determinato Bene
 * Culturale
 * 
 * @author Martone Giuseppe
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */
public interface IDBVisitaBC
{

	/**
	 * Inserisce una visita
	 * 
	 * @param pVisita Visita da inserire
	 * @throws SQLException
	 */
	public boolean inserisciVisitaBC(BeanVisitaBC pVisita) throws SQLException;

	/**
	 * Modifica una visita
	 * 
	 * @param pVisita Visita da modificare
	 * @throws SQLException
	 * @return True se e' stata modificata false altrimenti
	 */
	public boolean modificaVisitaBC(BeanVisitaBC pVisita) throws SQLException;

	/**
	 * Estrae la lista delle visite di un bene culturale
	 * 
	 * @param pIdBeneCulturale Identificativo del bene culturale
	 * @throws SQLException
	 * @return Lista delle visite del bene culturale
	 */
	public ArrayList<BeanVisitaBC> ottieniListaVisitaBC(int pIdBeneCulturale)
			throws SQLException;

	/**
	 * Estrae la lista dei beni culturali visitati da un turista
	 * 
	 * @param pIdTurista Identificativo del turista
	 * @throws SQLException
	 * @return ArrayList di tutti i feedback rilasciati da un turista per un
	 *         determinato bene culturale
	 */
	public ArrayList<BeanVisitaBC> ottieniListaVisitaBCTurista(int pIdTurista)
			throws SQLException;

	/**
	 * Estrae una visita effettuata da un turista ad un bene culturale
	 * 
	 * @param pIdBeneCulturale Identificativo del bene culturale
	 * @param pIdTurista Identificativo del turista
	 * @throws SQLException
	 * @return Visita
	 */
	public BeanVisitaBC ottieniVisitaBC(int pIdBeneCulturale, int pIdTurista)
			throws SQLException;
}
