package unisa.gps.etour.repository;

import java.sql.SQLException;
import java.util.ArrayList;

import unisa.gps.etour.bean.BeanVisitaPR;

/**
 * Interfaccia per la gestione dei feedback relativi ad un determinato Punto di
 * Ristoro
 * 
 * @author Martone Giuseppe
 * @version 0.1 � 2007 eTour Project - Copyright by SE@SA Lab DMI � University
 *          of Salerno
 */
public interface IDBVisitaPR
{

	/**
	 * Aggiunge una visita ad un punto di ristoro
	 * 
	 * @param pVisita Visita da aggiungere
	 * @throws SQLException
	 */
	public boolean inserisciVisitaPR(BeanVisitaPR pVisita) throws SQLException;

	/**
	 * Modifica una visita
	 * 
	 * @param pVisita Visita da modificare
	 * @throws SQLException
	 * @return True se e' stata modificata false altrimenti
	 */
	public boolean modificaVisitaPR(BeanVisitaPR pVisita) throws SQLException;

	/**
	 * Estrae la lista delle visite di un punto di ristoro
	 * 
	 * @param pIdPuntoDiRistoro Identificativo del punto di ristoro
	 * @throws SQLException
	 * @return Lista delle visite
	 */
	public ArrayList<BeanVisitaPR> ottieniListaVisitaPR(int pIdPuntoDiRistoro)
			throws SQLException;

	/**
	 * Estrae una visita effettuata da un turista ad un punto di ristoro
	 * 
	 * @param pIdPuntoDiRistoro Identificativo del punto di ristoro
	 * @param pIdTurista Identificativo del turista
	 * @throws SQLException
	 * @return Visita
	 */
	public BeanVisitaPR ottieniVisitaPR(int pIdPuntoDiRistoro, int pIdTurista)
			throws SQLException;

	/**
	 * Estrae la lista delle visite di un Turista
	 * 
	 * @param pIdTurista Identificativo del turista
	 * @return Lista delle visite
	 * @throws SQLException
	 */
	public ArrayList<BeanVisitaPR> ottieniListaVisitaPRTurista(int pIdTurista)
			throws SQLException;

}
