/**
 * Interfaccia che offre i servizi di gestione dell'advertisement 
 * all'operatore agenzia.
 *
 * @author Autore
 * @version 0.1
 * 
 *  2007 eTour Project - Copyright by SE@SA Lab DMI  University of Salerno
 */
package com.trapan.spg.control.GestioneAdvertisement;

import java.rmi.RemoteException;
import java.util.ArrayList;

import com.trapan.spg.bean.BeanNews;

public interface IGestioneAdvetisementAgenzia extends IGestioneAdvertisement
{
	/**
	 * Metodo che inserisce una nuova news nel sistema.
	 * 
	 * @param pNews Bean contenente i dati della news
	 * @throws RemoteException
	 */
	public boolean inserisciNews(BeanNews pNews) throws RemoteException;
	/**
	 * Metodo che cancella una news dal sistema.
	 *
	 * @param pNewsID ID della news da cancellare.
	 * @throws RemoteException
	 */
	public boolean cancellaNews(int pNewsID) throws RemoteException;
	/**
	 * Metodo che modifica il testo di una news.
	 *
	 * @param pNews Bean contenente i dati della news 
	 * @throws RemoteException
	 */
	public boolean modificaNews(BeanNews pNews) throws RemoteException;
	/**
	 * Restituisce la lista delle news attive.
	 *
	 * @return ArrayList ArrayList di News
	 * @throws RemoteException
	 */
	public ArrayList<BeanNews> ottieniAllNews() throws RemoteException;
}
