package unisa.gps.etour.gui.operatoreagenzia.documents;

import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.PlainDocument;

public class LimitedDocument extends PlainDocument
{
	private static final long serialVersionUID = 1L;
	private int maxLength;

	public LimitedDocument(int pMaxLength)
	{
		maxLength = pMaxLength;
	}
	
	public void insertString(int pOffset, String pStringa, AttributeSet pAttribute) throws BadLocationException
	{
		if (pStringa == null) 
		{
			return;
		}
		//Nota: il content ha sempre un carattere di newline alla fine
		int capacity = maxLength + 1 - getContent().length();
		// Se la massima lunghezza  maggiore o uguale della stringa, la inserisce.
		if (capacity >= pStringa.length()) 
		{
			super.insertString(pOffset, pStringa, pAttribute);
		} 
		//Altrimenti aggiunge quello che pu
		else 
		{
			if (capacity > 0) 
			{
				super.insertString(pOffset, pStringa.substring(0,capacity), pAttribute);
			}
		}
	}
}
