package unisa.gps.etour.control.GestioneRicerche;

import java.sql.SQLException;
import java.util.ArrayList;

/**
 * Classe per la gestione della Ricerca Standard
 * 
 * @author Penna Giuseppe
 * @version 0.1 &#169; 2007 eTour Project - Copyright by SE@SA Lab DMI -
 *          University of Salerno
 */
public class RicercaStandard extends Ricerca
{

	/** Costruttore della classe
	 * 
	 */
	public RicercaStandard()
	{

	}

	protected int ottieniNumeroElementiRicercaSpecializzato()
			throws SQLException
	{	
		// Controlla la tipologia di sito e ottiene il numero di risultati
		switch (pTipologiaSito)
		{
			case BENE_CULTURALE:
				return BeneCulturale.ottieniNumeroElementiRicerca(
						this.pParoleChiave, this.pTags, this.pPosizioneUtente,
						this.pRaggioMax);
			case PUNTO_DI_RISTORO:
				return PuntoDiRistoro.ottieniNumeroElementiRicerca(
						this.pParoleChiave, this.pTags, this.pPosizioneUtente,
						this.pRaggioMax);
			default:
				return -1;
		}
	}

	protected ArrayList<?> ricercaSpecializzataPerPagina(int pNumeroPagina)
			throws SQLException
	{
		// Controlla la tipologia di sito ed effettua la ricerca
		switch (pTipologiaSito)
		{
			case BENE_CULTURALE:
				return BeneCulturale.ricerca(pParoleChiave, pTags,
						pNumeroPagina, numeroElementiPerPagina,
						pPosizioneUtente, pRaggioMax);
			case PUNTO_DI_RISTORO:
				return PuntoDiRistoro.ricerca(pParoleChiave, pTags,
						pNumeroPagina, numeroElementiPerPagina,
						pPosizioneUtente, pRaggioMax);
			default:
				return null;

		}
	}
}
